
'##################################################################################################
'Code settings.
Strict

'##################################################################################################
'Framework & Imports.
Framework BRL.GLMax2D
Import BRL.PolledInput
Import BRL.StandardIO
Import BRL.Retro
Import BRL.BMPLoader
Import BRL.PNGLoader
Import "Source\Res\Res.o"

'##################################################################################################
'Includes
Include "Source\Global.bmx"

Include "Source\Function\Color.bmx"
Include "Source\Function\DrawSquare.bmx"
Include "Source\Function\GenRGB.bmx"
Include "Source\Function\RectsOverlap.bmx"
Include "Source\Function\DrawOutlinedText.bmx"

Include "Source\Class\TApp.bmx"
Include "Source\Class\TGraphicsHandle.bmx"
Include "Source\Class\TMouse.bmx"
Include "Source\Class\TKeyboard.bmx"

Include "Source\Class\Interface\Interface.bmx"

'##################################################################################################
'Initialize
TGraphicsHandle.Create()
TInterface.Init()

Global Menu:TUIWindow = TUIWindow.Create( 0, 0, 120, 200, "MaxRPG", UIWINDOW_DEFAULT | UIWINDOW_CENTERED )
Global Btn:TUIButton = Menu.AddButton( 5, 5, Menu.ClientWidth() - 10, 20, "Start Demo", 0 )

Rem
Global TestWindow:TUIWindow = TUIWindow.Create( 100, 100, 300, 150, "Test Window", UIWINDOW_DEFAULT )
TestWindow.AddButton( 10, 10, 100, 20, "Click me!", 0 )

Global TestWindow2:TUIWindow = TUIWindow.Create( 200, 200, 400, 300, "BIG WINDOW!", UIWINDOW_DEFAULT )
TestWindow2.AddButton( 10, 10, 100, 20, "Click me!", 0 )
TestWindow2.AddButton( 100, 100, 200, 60, "Click me!", 0 )
TestWindow2.AddProgBar( 10, 40, 100, 20, 0 )
TestWindow2.AddTextInput( 10, 200, 200, 20, 0 )
End Rem

'##################################################################################################
'Main Loop
While Not KeyHit( KEY_ESCAPE ) Or AppTerminate()
	TApp.Update()
	TMouse.Update()
	TKeyboard.Update()
	TInterface.Update()
	
	Flip( 0 );Cls
Wend
TApp.Close()

'##################################################################################################