
Const EVENT_UIACTION:Int = 1
	Const UIACTION_WINDOWHIT:Int = 1
	Const UIACTION_PANELHIT:Int = 2
	Const UIACTION_BUTTONHIT:Int = 3
	Const UIACTION_PROGBARHIT:Int = 4

Type TInterface
	
	Global Focus:Int
	
	Function Init()
		TUIWindow.CreateGradient()
		TUIButton.CreateGradient()
		TUIProgBar.CreateGradient()
		TUITextInput.CreateGradient()
	End Function
	
	Function Update()
		
		If TMouse.Locked() = False
			TMouse.Target = TMouse.CheckUICol()
		
			If TMouse.Target <> Null
				OnMouseOver()
			EndIf
			
			If TMouse.LastTarget <> TMouse.Target
				OnMouseLeave()
			EndIf
		EndIf
				
		If TMouse.Down( MOUSE_LEFT )
			If TMouse.Locked() = False
				If TMouse.Target <> Null
					OnMouseHit()
				EndIf
			Else
				OnMouseDown()
			EndIf
		Else
			OnMouseRelease()
			TMouse.LastTarget = TMouse.Target
			TMouse.Target = Null
			TMouse.Unlock()
		EndIf
		
		TUIWindow.UpdateALL()
	End Function
	
	Function OnMouseLeave()
		If TUIButton( TMouse.LastTarget ) Then TUIButton( TMouse.LastTarget ).State = 0
	End Function
	
	Function OnMouseOver()
		If TUIButton( TMouse.Target ) Then TUIButton( TMouse.Target ).State = 1
	End Function
	
	Function OnMouseHit()
		'Window
		If TUIWindow( TMouse.Target ) Then TMouse.Lock();TUIWindow( TMouse.Target ).BringToFront()
		EmitEvent( CreateEvent( EVENT_UIACTION, TMouse.Target, UIACTION_WINDOWHIT, 0, 0, 0, Null ) )
		
		'Panel
		If TUIPanel( TMouse.Target ) Then TUIWindow( TUIPanel( TMouse.Target ).Parent ).BringToFront()
		EmitEvent( CreateEvent( EVENT_UIACTION, TMouse.Target, UIACTION_PANELHIT, 0, 0, 0, Null ) )
		
		'TextInput
		If TUITextInput( TMouse.Target ) Then
			TMouse.Lock()
			TUIWindow( TUIPanel ( TUITextInput( TMouse.Target ).Parent ).Parent).BringToFront()
		EndIf
		
		'Button
		If TUIButton( TMouse.Target ) Then
			TMouse.Lock()
			TUIWindow( TUIPanel ( TUIButton( TMouse.Target ).Parent ).Parent).BringToFront()
			EmitEvent( CreateEvent( EVENT_UIACTION, TMouse.Target, UIACTION_BUTTONHIT, 0, 0, 0, Null ) )
		EndIf
		
		'Progbar
		If TUIProgBar( TMouse.Target ) Then
			TMouse.Lock()
			TUIProgBar( TMouse.Target ).OnClick()
			TUIWindow( TUIPanel ( TUIProgBar( TMouse.Target ).Parent ).Parent).BringToFront()
			EmitEvent( CreateEvent( EVENT_UIACTION, TMouse.Target, UIACTION_PROGBARHIT, 0, 0, 0, Null ) )
		EndIf
	End Function
	
	Function OnMouseDown()
		If TUIWindow( TMouse.Target ) Then TUIWindow( TMouse.Target ).Drag()
		If TUIButton( TMouse.Target ) Then TUIButton( TMouse.Target ).State = 2
	End Function
	
	Function OnMouseRelease()
		If TUIWindow( TMouse.Target )
			TUIWindow( TMouse.Target ).StopDrag()
		EndIf
	End Function
	
End Type