
Type TUIButton
	
	Global Gradient:TImage[2]
	
	Field Parent:TUIPanel
	Field Text:String
	Field X:Int, Y:Int, W:Int, H:Int, LX:Int, LY:Int
	Field Img:TImage[3], Flags:Int, State:Int
	
	Function CreateGradient()
		Local PixMap:TPixmap = CreatePixmap( 1, 2, PF_I8 )
		WritePixel( PixMap, 0, 0, GenRGB( 255, 255, 255, 255 ) )
		WritePixel( PixMap, 0, 1, GenRGB( 195, 195, 195, 255 ) )
		
		TUIButton.Gradient[0] = LoadImage( PixMap )
		
		PixMap = CreatePixmap( 1, 2, PF_I8 )
		WritePixel( PixMap, 0, 0, GenRGB( 195, 195, 195, 255 ) )
		WritePixel( PixMap, 0, 1, GenRGB( 255, 255, 255, 255 ) )
		
		TUIButton.Gradient[1] = LoadImage( PixMap )
	End Function
	
	Function Create:TUIButton( Window:TUIWindow, X:Int, Y:Int, W:Int, H:Int, Text:String, Flags:Int )
		Local B:TUIButton = New TUIButton
			B.Parent = Window.Panel
			B.LX = X
			B.LY = Y
			B.W= W
			B.H = H
			B.Text = Text
			B.Flags = Flags
			B.UpdateShape()
			
			ListAddLast( B.Parent.ChildList, B )
			
			Return B
	End Function
	
	Method UpdateShape()
		
		SetClsColor 255, 0, 255
		Cls
		
		'Img[0] (Button in normal state)
		SetColor 147, 172, 206
		DrawImageRect( Gradient[0], 0, 0, W, H )
		SetColor 0, 0, 0
			DrawSquare( 0, 0, W, H )
		SetColor 205, 217, 233
			DrawOutlinedText( Text, W/2, H/2 + 4, 3 )
		SetColor 255, 0, 255
			Plot 0, 0
			Plot W-1, H-1
			Plot W-1, 0
			Plot 0, H-1
		SetColor 255, 255, 255
		
		
		Img[0] = LoadImage( MaskPixmap( GrabPixmap( 0, 0, W, H ), 255, 0, 255 ) )
		Cls
		
		'Img[1] (Hovering over button)
		SetColor 207, 218, 233
			DrawImageRect( Gradient[0], 0, 0, W, H )
		SetColor 0, 0, 0
			DrawSquare( 0, 0, W, H )
		SetColor 255, 255, 255
			DrawOutlinedText( Text, W/2, H/2 + 4, 3 )
		SetColor 255, 0, 255
			Plot 0, 0
			Plot W-1, H-1
			Plot W-1, 0
			Plot 0, H-1
		SetColor 255, 255, 255
		
		Img[1] = LoadImage( MaskPixmap( GrabPixmap( 0, 0, W, H ), 255, 0, 255 ) )
		
		'Img[2] (Butting being pressed down)
		SetColor 55, 55, 110
			DrawImageRect( Gradient[1], 0, 0, W, H )
		SetColor 0, 0, 0
			DrawSquare( 0, 0, W, H )
		SetColor 131, 159, 199
			DrawOutlinedText( Text, W/2, H/2 + 4, 3 )
		SetColor 255, 0, 255
			Plot 0, 0
			Plot W-1, H-1
			Plot W-1, 0
			Plot 0, H-1
		SetColor 255, 255, 255
		
		Img[2] = LoadImage( MaskPixmap( GrabPixmap( 0, 0, W, H ), 255, 0, 255 ) )
		
		TGraphicsHandle.ResetCLSColor()
		Cls
		
	End Method
	
	Method Update()
		
		X = Parent.X + LX
		Y = Parent.Y + LY
		
		If State = 0
			If Img[0] <> Null
				DrawImage( Img[0], X, Y )
			EndIf
		ElseIf State = 1
			If Img[1] <> Null
				DrawImage( Img[1], X, Y )
			EndIf
		ElseIf State = 2
			If Img[2] <> Null
				DrawImage( Img[2], X, Y )
			EndIf
		EndIf
		
	End Method
	
End Type
