
Const UIPROGBAR_DEFAULT:Int 	= 0
Const UIPROGBAR_BACKGROUND:Int 	= 1
Const UIPROGBAR_BORDER:Int		= 2
Const UIPROGBAR_TEXT:Int		= 4
Const UIPROGBAR_SLIDER:Int		= 8
Const UIPROGBAR_CLICKABLE:Int	= 16

Type TUIProgBar
	
	Global Gradient:TImage
	
	Field Parent:TUIPanel
	Field X:Int, Y:Int, W:Int, H:Int, LX:Int, LY:Int
	Field Flags:Int, Progress:Int, Img:TImage[2]
	
	Function CreateGradient()
		Local PixMap:TPixmap = CreatePixmap( 1, 2, PF_I8 )
		WritePixel( PixMap, 0, 0, GenRGB( 255, 255, 255, 255 ) )
		WritePixel( PixMap, 0, 1, GenRGB( 195, 195, 195, 255 ) )
		
		TUIProgBar.Gradient = LoadImage( PixMap )
	End Function
	
	Function Create:TUIProgBar( Window:TUIWindow, X:Int, Y:Int, W:Int, H:Int, Flags:Int )
		
		Local P:TUIProgBar = New TUIProgBar
			P.Parent = Window.Panel
			P.LX = X
			P.LY = Y
			P.W = W
			P.H = H
			P.Flags = Flags
			P.Progress = 50
			
			If P.Flags = UIPROGBAR_DEFAULT
				P.Flags = UIPROGBAR_BACKGROUND | UIPROGBAR_BORDER | UIPROGBAR_TEXT
			EndIf
			
			P.UpdateShape()
			
			ListAddLast( P.Parent.ChildList, P )
			
			Return P
			
	End Function
	
	Method OnClick()
		Progress = Float(MouseX()-(X+1)) / Float( (W-3) ) * 100
	End Method
	
	Method UpdateShape()
		
		SetClsColor 255, 0, 255
		Cls
		
		'Background
		SetColor 112, 146, 190
			DrawImageRect( Gradient, 0, 0, W, H )
		SetColor 0, 0, 0
			DrawSquare( 0, 0, W, H )
		SetColor 255, 0, 255
			Plot( 0, 0 )
			Plot( W-1, 0 )
			Plot( W-1, H-1 )
			Plot( 0, H-1 )
		SetColor 255, 255, 255
		
		Img[0] = LoadImage( MaskPixmap( GrabPixmap( 0, 0, W, H ), 255, 0, 255 ) )
		Cls
		
		'Filling
		SetColor 181, 198, 221
			DrawImageRect( Gradient, 0, 0, W, H )
		SetColor 255, 255, 255
		
		Img[1] = LoadImage( MaskPixmap( GrabPixmap( 0, 0, W, H ), 255, 0, 255 ) )
		
		TGraphicsHandle.ResetCLSColor()
		Cls
		
	End Method
	
	Method Update()
		
		X = Parent.X + LX
		Y = Parent.Y + LY
		
		If Img[0] <> Null
			DrawImage( Img[0], X, Y )
		EndIf
		If Img[1] <> Null
			DrawImageRect( Img[1], X+1, Y+1, (W-2)*Float(Progress/100.0), H-2 )
		EndIf
		If Flags&UIPROGBAR_TEXT Then
			DrawOutlinedText( Progress+"%", X+W/2, Y+2+H/2, 3 )
		EndIf
		
	End Method
	
End Type
