
Type TUITextInput
	
	Global Gradient:TImage
	
	Field Parent:TUIPanel, Flags:Int, Img:TImage
	Field X:Int, Y:Int, W:Int, H:Int, LX:Int, LY:Int
	Field Text:TList
	
	Function CreateGradient()
		Local PixMap:TPixmap = CreatePixmap( 1, 2, PF_I8 )
		WritePixel( PixMap, 0, 0, GenRGB( 255, 255, 255, 255 ) )
		WritePixel( PixMap, 0, 1, GenRGB( 195, 195, 195, 255 ) )
		
		TUITextInput.Gradient = LoadImage( PixMap )
	End Function
	
	Function Create:TUITextInput( Window:TUIWindow, X:Int, Y:Int, W:Int, H:Int, Flags:Int )
		
		Local T:TUITextInput = New TUITextInput
			T.Parent = Window.Panel
			T.LX = X
			T.LY = Y
			T.W = W
			T.H = H
			T.Flags = Flags
			
			T.UpdateShape()
			
			ListAddLast( T.Parent.ChildList, T )
			
			Return T
		
	End Function
	
	Method UpdateShape()
		
		SetClsColor 255, 0, 255
		Cls
		
		SetColor 181, 198, 221
			DrawImageRect( TUITextInput.Gradient, 0, 0, W, H )
		SetColor 0, 0, 0
			DrawSquare( 0, 0, W, H )
		SetColor 255, 0, 255
			Plot( 0, 0 )
			Plot( W-1, 0 )
			Plot( 0, H-1 )
			Plot( W-1, H-1 )
		SetColor 255, 255, 255
		
		Img = LoadImage( MaskPixmap( GrabPixmap( 0, 0, W, H ), 255, 0, 255 ) )
		
		TGraphicsHandle.ResetCLSColor()
		Cls
		
	End Method
	
	Method Update()
	
		X = Parent.X + LX
		Y = Parent.Y + LY
		
		DrawImage( Img, X, Y )
		
	End Method
	
End Type
