
Const MOUSEFOCUS_OTHER:Int 	= 0
Const MOUSEFOCUS_INTERFACE:Int 	= 1
Const MOUSEFOCUS_GAME:Int		= 2

Const MOUSE_FREE:Int			= 0
Const MOUSE_BUSY:Int			= 1

Const MOUSE_LEFT:Int 			= 0
Const MOUSE_RIGHT:Int		= 1

Const MOUSEPOINTER_DEFAULT:Int	= 0
Const MOUSEPOINTER_INPUTTEXT:Int	= 1
Const MOUSEPOINTER_WORKING:Int	= 2
Const MOUSEPOINTER_CLOSE:Int	= 3

Type TMouse
	
	Global Enabled:Int = 1
	Global Button:Int[2]
	Global Target:Object, LastTarget:Object, TargetLock:Int
	Global LastPos:Int[3]
	Global Speed:Int[3]
	Global Pointer:TImage[10]
	
	Function Lock:Int()
		TargetLock = 1
		Return 1
	End Function
	
	Function Unlock:Int()
		TargetLock = 0
		Return 1
	End Function
	
	Function Locked:Int()
		If TargetLock = 1
			Return True
		EndIf
		Return False
	End Function
	
	Function Hit( Btn:Int = MOUSE_LEFT )
		If Button[ Btn ] = 1
			Return 1
		EndIf
		Return 0
	End Function
	
	Function Down( Btn:Int = MOUSE_LEFT )
		If Button[ Btn ] = 2
			Return 1
		EndIf
		Return 0
	End Function
	
	Function Update()
		
		If Enabled = 1
			Local Btn:Int
			For Btn = 0 To 1
				If MouseDown( Btn+1 )
					Select Button[ Btn ]
						Case 0
							Button[ Btn ] = 1
						Case 1
							Button[ Btn ] = 2
					End Select
				Else
					Button[ Btn ] = 0
				EndIf
			Next
		EndIf
		
		Speed[0] = MouseX() - LastPos[0]
		LastPos[0] = MouseX()
		
		Speed[1] = MouseY() - LastPos[1]
		LastPos[1] = MouseY()
		
		Speed[2] = MouseZ() - LastPos[2]
		LastPos[2] = MouseZ()
		
	End Function
	
	Function CheckUICol:Object()
		
		Local WindowList:TList = TList(TUIWindow.List.Copy())
		ReverseList( WindowList )
		
		Local W:TUIWindow
		Local B:TUIButton
		Local P:TUIProgBar
		Local T:TUITextInput
		
		For W = EachIn WindowList
			If TMouse.Collide( W.X, W.Y, W.W, W.H )
				For B = EachIn W.Panel.ChildList
					If TMouse.Collide( B.X, B.Y, B.W, B.H )
						Return B
					EndIf
				Next
				For T = EachIn W.Panel.ChildList
					If TMouse.Collide( T.X, T.Y, T.W, T.H )
						Return T
					EndIf
				Next
				For P = EachIn W.Panel.ChildList
					If TMouse.Collide( P.X+2, P.Y+2, P.W-3, P.H-3 )
						If P.Flags&UIPROGBAR_CLICKABLE
							Return P
						EndIf
					EndIf
				Next
				If TMouse.Collide( W.X+W.CX, W.Y+W.CY, W.CW, W.CH ) = False
					Return W
				EndIf
				
				If TMouse.Collide( W.Panel.X, W.Panel.Y, W.Panel.W, W.Panel.H )
					Return W.Panel
				EndIf
			EndIf
		Next
		
		Return Null
		
	End Function
	
	Function Collide:Int( X:Int, Y:Int, W:Int, H:Int )
		If RectsOverlap( MouseX(), MouseY(), 1, 1, X, Y, W, H ) Return 1
		Return 0
	End Function
	
	Function XSpeed()
		Return Speed[0]
	End Function
	
	Function YSpeed()
		Return Speed[1]
	End Function
	
	Function ZSpeed()
		Return Speed[2]
	End Function
	
End Type